#ifndef _OI_BT_H
#define _OI_BT_H

/**
 * Copyright (c) 2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *     * Neither the name of The Linux Foundation nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

/**
   @file
   This file contains a list of most of the header files.
 */

/* OEM headers */
#include "oi_wrapper.h"

/* General includes */
#include "oi_assert.h"
#include "oi_bt_assigned_nos.h"
#include "oi_bt_profile_config.h"
#include "oi_bt_spec.h"
#include "oi_bt_stack_config.h"
#include "oi_bt_stack_init.h"
#include "oi_common.h"
#include "oi_config_table.h"
#include "oi_connect_policy.h"
#include "oi_cpu_dep.h"
#include "oi_dataelem.h"
#include "oi_debugcontrol.h"
#include "oi_dump.h"
#include "oi_l2cap.h"
#include "oi_modules.h"
#include "oi_osinterface.h"
#include "oi_rfcomm.h"
#include "oi_rfcomm_prefs.h"
#include "oi_sdp.h"
#include "oi_sdpdb.h"
#include "oi_status.h"
#include "oi_statustext.h"
#include "oi_stddefs.h"
#include "oi_text.h"
#include "oi_time.h"
#include "oi_unicode.h"
#include "oi_utils.h"

/* Profiles */
#include "oi_bip_cli.h"
#include "oi_bip_spec.h"
#include "oi_bip_srv.h"
#include "oi_bnep.h"
#include "oi_bpp.h"
#include "oi_bpp_printer.h"
#include "oi_bpp_sender.h"
#include "oi_ftp_client.h"
#include "oi_ftp_file.h"
#include "oi_ftp_server.h"
#include "oi_ftp_sys.h"
#include "oi_obexcli.h"
#include "oi_obex_sd.h"
#include "oi_obexspec.h"
#include "oi_obexsrv.h"
#include "oi_opp_client.h"
#include "oi_opp_ofs.h"
#include "oi_opp_server.h"
#include "oi_opp_sys.h"

#endif /* _OI_BT_H */

